
CompilerIf Defined(PureZIP_Archive_Create, #PB_Function) = 0
  CompilerError " ,    PureZIP"
CompilerEndIf

; PureBasic Visual Designer v3.95 build 1485 (PB4Code)


;- Window Constants
;
Enumeration
  #Window_0
EndEnumeration

;- Gadget Constants
;
Enumeration
  #Text_0
  #String_0
  #Text_1
  #String_1
  #Text_2
  #Text_CurrentFiles
  #ProgressBar_FileProgress
  #Text_4
  #ProgressBar_AllProgress
  #Button_Archive
  #Button_1
  #Button_2
  #Text_5
  #String_Password
EndEnumeration

; WinAPI   - PureBasic.
CompilerIf Defined(MB_OK, #PB_Constant) = 0
  #MB_OK = 0 : #MB_YESNOCANCEL = 3
  #IDYES = 6 : #IDCANCEL       = 2
  #MB_ICONQUESTION    = 32
  #MB_DEFBUTTON2      = 256
  #MB_ICONWARNING     = 48
  #MB_ICONINFORMATION = 64
  #MB_ICONERROR       = 16
  #SS_LEFTNOWORDWRAP  = 12
CompilerEndIf

; ,    .
Global NewList Files.s(), ProgName.s=ProgramFilename()

;    .
Procedure.s Cut_FileName(File.s)
  Protected Result.s
  Result = File

  If Len(File) > 34
    Count = CountString(File, "\")
    If Count > 2
      Pos=FindString(File, "\", 1)
      If Pos > 0
        Pos = FindString(File, "\", Pos+1)
        If Pos > 0
          Result = Left(File, Pos)+"...\"+GetFilePart(File)
        EndIf
      EndIf
    EndIf
  EndIf  
    
  ProcedureReturn Result
EndProcedure

;        .
Procedure Find_File(Path.s, Sub.s)
  
  If Right(Path.s,1)<>"\":Path + "\":EndIf
  
  ;   .
  Directory = ExamineDirectory(#PB_Any, Path, "*.*")
  If Directory
    While NextDirectoryEntry(Directory) ;   / .
      
      Type.l = DirectoryEntryType(Directory) ;   (  ).
      Name.s = DirectoryEntryName(Directory) ;  .
      
      If Type = #PB_DirectoryEntry_File ;  .
        AddElement( Files() )           ;    .
        Files() = Sub + Name            ;     .
      ElseIf Type = #PB_DirectoryEntry_Directory ;  
        If Name <> "." And Name <> ".." ;      .
           ;   .
          Find_File(Path + Name, Sub + Name + "\")
        EndIf
      EndIf
      
    Wend
    FinishDirectory(Directory) ;   .
  EndIf
  
EndProcedure

;   .
Procedure Button_Archive(Directory.s, File.s)
  
  Error = #True
  BreakCompress = #False
  
  SetGadgetText(#Text_CurrentFiles, " . ...")
  ClearList( Files() ) ;    .
  Find_File(Directory, "") ;  ,  .
  
  CountFiles = ListSize( Files() ) ;   .
  If CountFiles = 0 
    MessageRequester("", "    !", #MB_OK|#MB_ICONWARNING)
    ProcedureReturn
  EndIf
  
  SetGadgetAttribute(#ProgressBar_AllProgress, #PB_ProgressBar_Maximum, CountFiles)
  SetGadgetText(#Text_CurrentFiles, " ")
  CurrentDir.s = GetCurrentDirectory() ;     .
  
  If CreateFile(2, File) ;    
    WriteData(2, ?SFX_File, ?SFX_File_End-?SFX_File) ;    -   .
    CloseFile(2)
    
    Password.s = GetGadgetText(#String_Password) ;  
    PureZIP_SetArchivePassword(Password)

    If PureZIP_Archive_Create(File, #APPEND_STATUS_CREATEAFTER) ;     .
      SetCurrentDirectory(Directory)                            ;   
      Count = 0
      
      ForEach Files() ;    ,      
        
        Count + 1
        SetGadgetState(#ProgressBar_AllProgress, Count) ;    .
        SetGadgetText(#Text_CurrentFiles, Cut_FileName(Directory+Files()))
        Status = PureZIP_Archive_Compress(Files(), #True, @BreakCompress) ;  
        
        If BreakCompress = #True
          MessageRequester("", "   ", #MB_OK|#MB_ICONINFORMATION)
          Break
        EndIf
          
       If Status <> #Z_OK And Status <> -1
          MessageRequester("", "    "+Chr(10)+Files(),  #MB_OK|#MB_ICONERROR)
          Break
        EndIf
               
      Next
      
      PureZIP_Archive_Close() ;   .
      
      If CountFiles = Count
        Error = #False
        SetGadgetText(#Text_CurrentFiles, "SFX  ")
        MessageRequester("", "  .", #MB_OK|#MB_ICONINFORMATION)
      EndIf
      
    Else
      MessageRequester("", "      !", #MB_OK|#MB_ICONERROR)
    EndIf
  Else
    MessageRequester("", "   !", #MB_OK|#MB_ICONERROR)
  EndIf
  
  SetCurrentDirectory(CurrentDir) ;    .
  
  If Error = #True         ;   
    If FileSize(File) >= 0 ;   SFX   
      DeleteFile(File)     ;  .
    EndIf
    SetGadgetText(#Text_CurrentFiles, "SFX    ")
    SetGadgetState(#ProgressBar_FileProgress, 0)
    SetGadgetState(#ProgressBar_AllProgress,  0)
  EndIf
  
EndProcedure

Procedure Open_Window_0() ;     ().
  Flags=#PB_Window_MinimizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered
  If OpenWindow(#Window_0, 344, 256, 334, 264, "  ZIP",Flags)
    TextGadget(#Text_0, 5, 5, 320, 15, "    :")
    StringGadget(#String_0, 5, 20, 290, 20, "", #PB_String_ReadOnly)
    TextGadget(#Text_1, 5, 55, 320, 15, "     :")
    StringGadget(#String_1, 5, 70, 290, 20, "", #PB_String_ReadOnly)
    TextGadget(#Text_2, 5, 140, 100, 15, " :")
    TextGadget(#Text_CurrentFiles, 105, 140, 220, 15, "", #SS_LEFTNOWORDWRAP)
    ProgressBarGadget(#ProgressBar_FileProgress, 5, 155, 320, 15, 0, 100, #PB_ProgressBar_Smooth)
    TextGadget(#Text_4, 5, 185, 150, 15, " :")
    ProgressBarGadget(#ProgressBar_AllProgress, 5, 200, 320, 15, 0, 100, #PB_ProgressBar_Smooth)
    ButtonGadget(#Button_Archive, 80, 230, 190, 25, " SFX ")
    ButtonGadget(#Button_1, 300, 20, 30, 20, "...")
    ButtonGadget(#Button_2, 300, 70, 30, 20, "...")
    TextGadget(#Text_5, 5, 105, 85, 15, " :")
    StringGadget(#String_Password, 95, 100, 200, 20, "")
  EndIf
EndProcedure

 ;       
Procedure File_Progress(File.s, PerCent.f, *UserParam)
  SetGadgetState(#ProgressBar_FileProgress, PerCent)
  
  Repeat
    Event=WindowEvent()
    If Event=#PB_Event_CloseWindow
      If EventWindow() = #Window_0
        Flags=#MB_YESNOCANCEL|#MB_ICONQUESTION|#MB_DEFBUTTON2
        Select MessageRequester(GetFilePart(ProgName), "     ?", Flags)
          Case #IDYES
            End
          Case #IDCANCEL
            PokeL(*UserParam, #True)
            Break
        EndSelect
      EndIf
    EndIf
  Until Event = 0
  
  ProcedureReturn 0
EndProcedure


Open_Window_0()
PureZIP_SetCompressionCallback(@File_Progress()) ;     
HideWindow(#Window_0, 0)

Repeat ;   Repeat - Until
  Event = WaitWindowEvent() ;  
  
  If Event = #PB_Event_Gadget
    Select EventGadget()   ;     
      Case #Button_1       ;     
        Path.s=PathRequester("    ","")
        If FileSize(Path) = -2 ;  
          SetGadgetText(#String_0, Path)
        EndIf
        
      Case #Button_2       ;     
        File.s=SaveFileRequester("","","EXE |*.exe| |*.*",0)
        If File<>""
          If GetExtensionPart(File)="" ;    
            File+".exe"
          EndIf
          SetGadgetText(#String_1, File)
        EndIf 
        
      Case #Button_Archive ;   
        String1.s=GetGadgetText(#String_0)
        String2.s=GetGadgetText(#String_1)
        If String1<>"" And String2<>"" 
          Button_Archive(String1, String2)
        Else
          MessageRequester("", " !", 48)
        EndIf
        
    EndSelect   
  EndIf
  
Until Event = #PB_Event_CloseWindow
End

;        .
DataSection
  SFX_File:
  IncludeBinary "SFX.exe"
  SFX_File_End:
EndDataSection
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 161
; FirstLine = 134
; Folding = -
; EnableXP
; UseIcon = icon.ico
; Executable = CreateSFX_Archive.exe