CompilerIf Defined(PureZIP_Archive_Create, #PB_Function) = 0
  CompilerError " ,    PureZIP"
CompilerEndIf

;- Window Constants
Enumeration
  #Window_0
EndEnumeration

;- Gadget Constants
Enumeration
  #Text_0
  #String_PathExtract
  #Button_Browse
  #Button_Extract
  #Text_2
  #Text_3
  #Text_4
  #Text_ExtractFiles
  #ProgressBar_File
  #ProgressBar_All
EndEnumeration

; WinAPI   - PureBasic.
CompilerIf Defined(MB_OK, #PB_Constant) = 0
  #MB_OK = 0 : #MB_YESNOCANCEL = 3
  #IDYES = 6 : #IDCANCEL       = 2
  #MB_ICONQUESTION    = 32
  #MB_DEFBUTTON2      = 256
  #MB_ICONWARNING     = 48
  #MB_ICONINFORMATION = 64
  #MB_ICONERROR       = 16
  #SS_LEFTNOWORDWRAP  = 12
CompilerEndIf

;  
Global DoneFiles, ProgName.s=ProgramFilename()

;     ()
Procedure Open_Window_0()
  Flags = #PB_Window_MinimizeGadget | #PB_Window_TitleBar | #PB_Window_Invisible | #PB_Window_ScreenCentered
  If OpenWindow(#Window_0, 334, 311, 334, 172, " ZIP ", Flags)
    TextGadget(#Text_0, 5, 5, 315, 15, "  :")
    StringGadget(#String_PathExtract, 5, 20, 290, 20, "", #PB_String_ReadOnly)
    ButtonGadget(#Button_Browse, 300, 20, 24, 20, "...")
    ButtonGadget(#Button_Extract, 240, 140, 90, 25, "")
    TextGadget(#Text_2, 5, 148, 234, 16, "   ''.")
    ProgressBarGadget(#ProgressBar_File, 5, 65, 320, 15, 0, 100, #PB_ProgressBar_Smooth)
    TextGadget(#Text_3, 5, 50, 85, 15, " :")
    TextGadget(#Text_ExtractFiles, 95, 50, 230, 15, "", #SS_LEFTNOWORDWRAP)
    TextGadget(#Text_4, 5, 95, 175, 15, "  :")
    ProgressBarGadget(#ProgressBar_All, 5, 110, 320, 15, 0, 100, #PB_ProgressBar_Smooth)
  EndIf
EndProcedure

;     .
Procedure File_Progress(File.s, Percent.f, *UserParam)
  
  SetGadgetState(#ProgressBar_File, PerCent) ;     . 

  Repeat
    Event=WindowEvent()            ;   .
    If Event=#PB_Event_CloseWindow ;      .
      If EventWindow() = #Window_0
        Flags = #MB_YESNOCANCEL|#MB_ICONQUESTION|#MB_DEFBUTTON2
        Select MessageRequester(GetFilePart(ProgName), "     ?", Flags)
          Case #IDYES
            End
          Case #IDCANCEL
            PokeL(*UserParam, #True)
            Break
        EndSelect
      EndIf
    EndIf
  Until Event = 0
  
  ProcedureReturn 0
EndProcedure

;    
Procedure.s Cut_FileName(File.s)
  Protected Result.s
  Result = File

  If Len(File) > 34
    Count = CountString(File, "\")
    If Count > 2
      Pos=FindString(File, "\", 1)
      If Pos > 0
        Pos = FindString(File, "\", Pos+1)
        If Pos > 0
          Result = Left(File, Pos)+"...\"+GetFilePart(File)
        EndIf
      EndIf
    EndIf
  EndIf  
    
  ProcedureReturn Result
EndProcedure

;    ,    ExtractPath.
Procedure ExtractArchive(ExtractPath.s)
  GlobalInfo.unz_global_info ;  
  FileInfo.PureZIP_FileInfo
  
  BreakExtract = #False      ;   
  DoneFiles    = 2
  
  PureZIP_SetArchivePassword("") ;   
  
  ;     ( 0)  
  If PureZIP_GetFileInfo(ProgName, 0, @FileInfo) = #True 
    If FileInfo\flag & 1 = 1 ;  0  -   .
      Pass.s=InputRequester(GetFilePart(ProgName)+" -   !", "  ","")
      PureZIP_SetArchivePassword(Pass) ;  ,  .
    EndIf
  EndIf
  
  If PureZIP_Archive_Read(ProgName) ;   (  )
    
    PureZIP_Archive_GlobalInfo(@GlobalInfo) 
    NrOfCompressed.l = GlobalInfo\number_entry   ;    
    ReturnValue.l = PureZIP_Archive_FindFirst()  ;     .
    
    SetGadgetAttribute(#ProgressBar_All, #PB_ProgressBar_Maximum, NrOfCompressed)
    
    ;  (While - Wend)   ,   .
    While ReturnValue = #UNZ_OK
      If PureZIP_Archive_FileInfo(@FileInfo) = #UNZ_OK ;    (, ,  , CRC  . .)
        Status = PureZIP_Archive_Extract(ExtractPath, #True, @BreakExtract) ;    
        
        If BreakExtract = #True
          MessageRequester("", "  ", #MB_OK|#MB_ICONINFORMATION)
          Break
        EndIf
          
        If Status = #UNZ_OK ;    
          DoneFiles + 1
          SetGadgetText(#Text_ExtractFiles, Cut_FileName(ExtractPath+FileInfo\FileName))
          SetGadgetState(#ProgressBar_All, DoneFiles)
          ReturnValue = PureZIP_Archive_FindNext() ;     .
        Else
          MessageRequester("", "    "+Chr(10)+FileInfo\FileName, #MB_OK|#MB_ICONWARNING)
          Break
        EndIf
              
      EndIf
    Wend
    
    PureZIP_Archive_Close() ;  
    
    If ReturnValue = #UNZ_END_OF_LIST_OF_FILE
      SetGadgetText(#Text_ExtractFiles, "  ")
      MessageRequester(GetFilePart(ProgName), "  .", #MB_OK|#MB_ICONINFORMATION)
    Else ;       (    ).
      SetGadgetState(#ProgressBar_File, 0)
      SetGadgetState(#ProgressBar_All,  0)
      SetGadgetText(#Text_ExtractFiles, "")
    EndIf
    
  Else ;     .
    MessageRequester("", "    .", #MB_OK|#MB_ICONERROR)
  EndIf
  
EndProcedure


Open_Window_0() ;     ().
SetGadgetText(#String_PathExtract, GetPathPart(ProgName)) ;   .
PureZIP_SetCompressionCallback(@File_Progress()) ;     
HideWindow(#Window_0,0) ;    

Repeat ;    "Repeat - Until"
  Event = WaitWindowEvent() ;  
  
  If Event = #PB_Event_Gadget
    Select EventGadget() ;     
      Case #Button_Browse ;    
        Path.s=PathRequester("     ","")
        If FileSize(Path) = -2 ;  
          SetGadgetText(#String_PathExtract, Path)
        EndIf
        
      Case #Button_Extract ;    .
        Path.s=GetGadgetText(#String_PathExtract)
        If FileSize(Path) = -2 ;  
          ExtractArchive(Path)
        Else
          MessageRequester("", "     !", #MB_OK|#MB_ICONWARNING)
        EndIf
    EndSelect
  EndIf
  
Until Event = #PB_Event_CloseWindow ;   .
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 46
; FirstLine = 39
; Folding = -
; EnableXP
; UseIcon = icon.ico
; Executable = SFX.exe
; IncludeVersionInfo
; VersionField0 = 1.0.0.0
; VersionField1 = 1.0.0.0
; VersionField2 = PureBasic
; VersionField3 = SFX
; VersionField4 = 1.0
; VersionField5 = 1.0
; VersionField6 =   .
; VersionField7 = SFX
; VersionField8 = SFX
; VersionField12 =    "".
; VersionField17 = 0419 Russian